package NewObjects;

import java.io.*;
import java.util.*;

/* 
   Un MuInt int e` un Tipo Astratto MUTABLE della forma [n] con n un valore int. Su questi
   valori sono definite le operazioni get, add e prod con la segnatura data in APIMuInt.
   Ogni implementazione provvede a definire:
   	+ Un costruttore che inizializza il MuInt ad un int dato come argomento.
   	+ Un metodo toString per la presentazione, in aggiunta agli additionals che ritiene 
   	  opportuni.
   (1) Si fornisca un ADT MuInt1 per APIMuInt.
   (2) Lo si utilizzi per esprimere la seguente sequenza di assegnamenti C: 
   			int n1 = 3; int n2 =- 12; int n3 = 7; n1 *= n2; n2 += n1; n3 *= n2;
   	  e mostrare i valori ottenuti per n1, n2, n3.
*/


public class MuInt1 implements APIMuInt{
	private int val;
	/*
	 AF(c) = [n] iff c.val=n
	 I(c) = true
	*/
	public MuInt1(int n){
		val = n;
	}
	public void add (APIMuInt k){
		val+=((MuInt1)k).val;
	}
	public void mul (APIMuInt k){
		val*=((MuInt1)k).val;
	}
	public String toString(){
		return "[" + String.valueOf(val) + "]";
	}
}

